// pages/user/login/login.js
const app = getApp()
import {
  httpUtil,
  http
} from '../../../utils/util'
Page({

  /**
   * 页面的初始数据
   */
  data: {

  },
  getUserProfile(e) {
    wx.showLoading({
      title: "加载...",
      mask: true
    });
    var that = this
    // 推荐使用wx.getUserProfile获取用户信息，开发者每次通过该接口获取用户个人信息均需用户确认，开发者妥善保管用户快速填写的头像昵称，避免重复弹窗
    wx.getUserProfile({
      desc: '展示用户信息', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
      success: (res) => {
        wx.login({
          success: res1 => {
            app.globalData.code = res1.code
            let userInfo = res.userInfo
            that.setData({
              userInfo,
              show: true
            })
          }
        })
      },
      complete: (res) => {
        wx.hideLoading()
      }
    })
  },
  getPhoneNumber(e) {
    if (e.detail.encryptedData || e.detail.iv) {
      let code = getApp().globalData.code
      if (code) {
        httpUtil("/api/v1/get-token", "get", {
          code
        }).then(res => {
          if (res.token) {
            app.globalData.code = null
            let data = {
              token: res.token,
              encryptedData: e.detail.encryptedData,
              iv: e.detail.iv
            }
            httpUtil("/api/v1/login", "post", data).then(res1 => {
              let userInfo = this.data.userInfo
              wx.setStorageSync('userInfo', Object.assign(res1, userInfo))
              app.globalData.token = res1.token
              app.globalData.uid = res1.uid
              app.globalData.nickName=userInfo.nickName
              app.globalData.avatarUrl=userInfo.avatarUrl
              app.globalData.userInfo=userInfo
              console.log("登录成功！")
              wx.navigateBack({
                delta: 0,
              })
              var pages = getCurrentPages();//获取页面栈
              if (pages.length > 1) {
                //上一个页面实例对象
                var prePage = pages[pages.length - 2];
                prePage.onLoad(prePage.options)
              }
            })
          } else {
            console.log("token获取异常！")
          }
        })
      } else {
        console.log("调用wx.login出错或者code失效")
      }
    } else {
      console.log("获取用户手机号被拒！")
    }
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})